<template>
  <v-dialog
    ref="addChiTieu"
    v-model="dialog"
    max-width="600px"
    persistent
  >
    <v-card>
      <v-form ref="form">
        <v-card-title class="text-left info pa-1">
          <h4
            class="pa-2"
            style="color: #ffffff"
          >
            Thêm chi tiêu
          </h4>
          <v-icon
            right
            style="color: #ffffff"
            @click.native="dialog = false"
          >
            clear
          </v-icon>
        </v-card-title>

        <v-divider />

        <v-card-text>
          <v-container class="pt-0 pb-0 mb-0">
            <v-row>
              <v-col cols="5">
                <v-autocomplete
                  ref="spec"
                  v-model="chiTieuModel.status"
                  :items="lstStatus"
                  label="Trạng thái"
                  item-text="name"
                  item-value="id"
                  class="text-left"
                  return-object
                />
              </v-col>
              <v-col cols="7">
                <vuetify-money
                  ref="receiptSoTien"
                  v-model="chiTieuModel.so_tien"
                  label="Số Tiền"
                  class="text-right"
                  :options="optionsmoney"
                  hide-details=""
                  required
                  :rules="priceRule"
                  @focus="true"
                />
              </v-col>
            </v-row>
            <v-row>
              <v-col cols="12">
                <v-combobox
                  ref="refNoiDung"
                  v-model="chiTieuModel.noi_dung"
                  :items="lstNoiDung"
                  item-text="name"
                  item-value="name"
                  label="Nội dung chi"
                  required
                  clearable
                />
              </v-col>
              <!-- <v-col cols="3">
                <v-text-field
                  ref="receiptSoTien"
                  v-model="chiTieuModel.mua_giup"
                  label="Mua giúp"
                  required
                  clearable
                  align="left"
                />
              </v-col> -->
            </v-row>
            <v-row>
              <v-col cols="6">
                <v-autocomplete
                  ref="refBank"
                  v-model="chiTieuModel.bank_code"
                  :items="lstBank"
                  label="Ngân hàng"
                  item-text="name"
                  item-value="name"
                  return-object
                  @change="bankChange($event)"
                />
              </v-col>
              <v-col cols="6">
                <v-autocomplete
                  ref="spec"
                  v-model="chiTieuModel.ky_chi"
                  :items="lstKyChi"
                  label="Kỳ"
                  item-text="name"
                  item-value="name"
                  class="text-right"
                  return-object
                />
              </v-col>
            </v-row>
            <v-text-field
              ref="receiptSoTien"
              v-model="chiTieuModel.ghi_chu"
              label="Ghi Chú"
              clearable
              align="right"
            />

            <!-- <v-text-field
              ref="receiptSoTien"
              v-model="chiTieuModel.balance_in_month"
              label="Số tiền còn lại trong tháng"
              :rules="priceRule"
              required
              clearable
              align="right"
            /> -->
          </v-container>
          <label>Amount: </label>
          <numeric-input
            v-model="amount"
            placeholder="touch to input"
          />
        </v-card-text>

        <v-divider />

        <v-card-actions class="pt-2 text-left">
          <v-spacer />
          <v-btn
            color="primary"
            @click="addChiTieu()"
          >
            Lưu
            <v-icon right>
              save
            </v-icon>
          </v-btn>
        </v-card-actions>
      </v-form>
    </v-card>
  </v-dialog>
</template>

<script>
  import axios from 'axios'
  import { NumericInput } from 'numeric-keyboard'
  import config from '../../config/config.js'

  export default {
    layout: 'addstorage',
    components: {
      NumericInput,
    },
    props: {
      // change the layout of keyboard
      layout: {
        type: [String, Array],
        default: 'number',
      },
      // change the label of keyboard enter key, use iconfont for icon.
      entertext: {
        type: String,
        default: 'enter',
      },
    },
    data () {
      return {
        dialog: false,
        amount: '',
        chiTieuModel: {},
        lstBank: [],
        lstKyChi: ['12019',
                   '22019',
                   '32019',
                   '42019',
                   '52019',
                   '62019',
                   '72019',
                   '82019',
                   '92019',
                   '102019',
                   '112019',
                   '122019',
                   '12020',
                   '22020',
                   '32020',
                   '42020',
                   '52020',
                   '62020',
                   '72020',
                   '82020',
                   '92020',
                   '102020',
                   '112020',
                   '122020',
                   '12021',
                   '22021',
                   '32021',
                   '42021',
                   '52021',
                   '62021',
                   '72021',
                   '82021',
                   '92021',
                   '102021',
                   '112021',
                   '122021',
        ],
        lstStatus: [
          {
            id: 'DCHI',
            name: 'Dự Chi',
          },
          {
            id: 'CHM',
            name: 'Cho Mượn',
          },
          {
            id: 'DTT',
            name: 'Đã Tất Toán',
          },
          {
            id: 'DN',
            name: 'Dư Nợ',
          },
          {
            id: 'DTCSK',
            name: 'Đã Trả / CSK',
          },
          {
            id: 'DTN',
            name: 'Đã trả nợ',
          },
          {
            id: 'NHT',
            name: 'Nhận tiền',
          },
          {
            id: 'HTN',
            name: 'Hoàn Tiền',
          },
          {
            id: 'MNT',
            name: 'Mượn Tiền',
          },

        ],
        lstNoiDung: ['CHỢ', 'GA', 'RÁC', 'PARTY', 'KHÁC', 'ĐIỆN - TP', 'ĐIỆN - QUÊ', 'NƯỚC - TP', 'INTERNET - TP'],
        nameRules: [(v) => !!v || 'The field is required'],
        numberRule: [(v) => !!v || 'The field is required'],
        priceRule: [(v) => !!v || 'The field is required'],
        specRule: [(v) => !!v || 'The field is required'],
        dvtRules: [(v) => !!v || 'The field is required'],
        optionsmoney: {
          locale: 'pt-BR',
          prefix: '',
          suffix: '',
          length: 11,
          precision: 0,
        },
      }
    },
    computed  () {
      this.$refs.receiptSoTien.focus()
    },
    mounted () {
      this.chiTieuModel.status = 'DN'
      this.getBanks()
    // this.bankChange('HSBC')
    }, // end method
    created () {
    }, // end data
    methods: {
      validate () {
        let flag = true
        this.$refs.form.validate()
        this.$nextTick(function () {
          // Product name

          if (!this.$refs.receiptquatity.validate()) {
            flag = false
            this.$refs.receiptquatity.focus()
          } else if (!this.$refs.receiptSoTien.validate()) {
            flag = false
            this.$refs.receiptSoTien.focus()
          } else if (!this.$refs.receipspec.validate()) {
            flag = false
            this.$refs.receipspec.focus()
          }

          return flag
        })
      },
      async addChiTieu () {
        const seft = this
        console.log(this.chiTieuModel)
        await axios
          .post(config.API_FAMILY + '/api/insertChiTieu', this.chiTieuModel)
          .then(function (response) {
            seft.dialog = false
            // console.log('Valid store ok')
            // console.log(response.data.data)
            self.chiTieuModel = []
            seft.$emit('refeshList')
          })
      },
      refeshList () {
        this.dialog = false
        this.$emit('refeshList')
      },
      async getBanks () {
        const seft = this
        await axios
          .get(config.API_FAMILY + '/api/banks')
          .then(function (response) {
            // this.insertChitieuDialog.dialog = false;
            console.log(response.data.data)
            seft.lstBank = response.data.data
          })
      },
      bankChange ($event) {
        var bank = 'HSBC'
        console.log(new Date().getDate())
        console.log(new Date().getMonth())
        var ky_chi = this.getKyTinh(this.chiTieuModel.bank_code, new Date(), new Date().getDate())
        if (this.chiTieuModel != undefined && this.chiTieuModel.bank_code != undefined && this.chiTieuModel.bank_code != null) {
          bank = this.chiTieuModel.bank_code
          console.log('281:' + this.chiTieuModel.bank_code)
          ky_chi = this.getKyTinh(this.chiTieuModel.bank_code, new Date(), new Date().getDate())
        } else {
          this.chiTieuModel.bank_code = bank
          console.log('aaaaaaaaaa:' + this.chiTieuModel.bank_code)
          ky_chi = this.getKyTinh(this.chiTieuModel.bank_code, new Date(), new Date().getDate())
        }
        this.chiTieuModel.ky_chi = ky_chi
        this.chiTieuModel.status = 'DN'
      },
      /** Function tra ve thang cua ky tinh toan */
      getKyTinh (sbankObj, sDate, sDay) {
        var kyTinh = ''
        var deltaMonth = 1
        var month = sDate.getMonth()
        var deltaYear = 0
        if (sbankObj != undefined && sbankObj != null) {
          var sBanName = sbankObj.name
          if (((sBanName == 'HSBC' || sBanName == 'SHINHAN') && (sDay + 1) >= 21) ||
            (sBanName == 'SC BANK' && (sDay + 1) >= 19) ||
            (sBanName == 'CitiBank' && (sDay + 1) >= 27)) {
            deltaMonth = 2
          } else {
            deltaMonth = 1
          }

          if (sDate.getMonth() + deltaMonth > 12) {
            deltaYear = 1
            kyTinh = '1' + (sDate.getFullYear() + deltaYear).toString()
          } else {
            kyTinh = (month + deltaMonth).toString() + (sDate.getFullYear() + deltaYear).toString()
          }
        }
        console.log('year:' + sDate.getFullYear())
        console.log('kyTinh-' + sBanName + ':' + kyTinh)
        return kyTinh
      },
    }, // end created
  } // End exxport default
</script>
<style scoped>
.text-right {
  text-align: right;
}
.text-center {
  text-align: center;
}
table tr td {
  padding: 0 8px !important;
}

.table-list table thead tr th {
  background-color: #2196f3 !important;
  color: #ffffff;
}
.table-list table {
  border-collapse: collapse !important;
  border: 1px solid gray !important;
}
</style>
